Attribute VB_Name = "FISCHER"
'Variables globales
Public motor1, motor2 As String
Public MotorValores As Byte


'motor(num, dir)     Operates the designated motor (num = 1 to  8)
'                    according to dir (A , L , R).
'                    P = off
'                    I = left
'                    D = right

Public Sub motor(num As Byte, dir As String)
    
Select Case dir    ' which direction

Case "P"           ' off
   
   MotorValores = LimpiarBit(MotorValores, (num * 2))         ' clear left and right bit
   MotorValores = LimpiarBit(MotorValores, (num * 2 - 1))

Case "I"           ' on left
   
   MotorValores = LimpiarBit(MotorValores, (num * 2))         ' clear right bit
   MotorValores = PonerBit(MotorValores, (num * 2 - 1))       ' set left bit

Case "D"           ' on right

   MotorValores = PonerBit(MotorValores, (num * 2))           ' set right bit
   MotorValores = LimpiarBit(MotorValores, (num * 2 - 1))     ' clear left bit

End Select

result = Leer_Entrada_Digital()       ' write motorbyte to the interface

End Sub

Public Sub apagar_motores()

MotorValores = 0                ' reset all
result = Leer_Entrada_Digital()           ' send motorsettings to interface
motor1 = "P"
motor2 = "P"
    
End Sub

' clear bit (bit) in Byte (wert)

Public Function LimpiarBit(wert As Byte, bit) As Byte

bitvorne = 2 ^ bit                  '
vorne = wert \ bitvorne
bithinten = 2 ^ (bit - 1)
hinten = wert Mod bithinten

LimpiarBit = vorne * bitvorne + hinten

End Function



' set bit (bit) in Byte (wert)
'
Public Function PonerBit(wert As Byte, bit) As Byte

bitvorne = 2 ^ bit                  '
vorne = wert \ bitvorne
vorne = vorne * 2 + 1
bithinten = 2 ^ (bit - 1)
hinten = wert Mod bithinten

PonerBit = vorne * bithinten + hinten

End Function

'Escribir_Salidas_Digitales(byte word)   Outputs  a full word that controls all  motor
'                         outputs 1 to 8 at the same time.
'
Public Sub Escribir_Salidas_Digitales(word As Byte)

MotorValores = word             ' set motorsettings
result = Leer_Entrada_Digital()           ' to interface

End Sub

'conmutador(num)      Get  the  current  state  of  the  designated
'                    swhich input (num = E1 to E8). If the  input
'                    is off, 0 is returned. If on, 1 is returned.
'
Public Function conmutador(num As Byte) As Byte

Dim result As Byte

result = Leer_Entrada_Digital()               ' read the inputstatus
conmutador = testBit(result, num)    ' which value has the interesting bit

End Function

' which value has bit (bit) in Byte (wert)?

Public Function testBit(wert As Byte, bit) As Byte

bitvorne = 2 ^ bit                  '
vorne = wert \ bitvorne
vorne = vorne * bitvorne

bithinten = 2 ^ (bit - 1)
hinten = wert Mod bithinten

testBit = (wert - vorne - hinten) / bithinten
End Function



'Leer_Entrada_Digital()        Gets a full word representing all inputs (1..8).
'
Public Function Leer_Entrada_Digital() As Byte

FormFischer.FischerComm.Output = Chr$(193) + Chr$(MotorValores)     ' command and motorsettings to interface
contador = 0
Do
    inString$ = FormFischer.FischerComm.Input       ' read the one byte of inputstatus
    contador = contador + 1
Loop Until (Len(inString$) >= 1) Or (contador = 100000)
If contador = 100000 Then End

Entradas = Asc(inString$)
Leer_Entrada_Digital = Entradas                                ' return the inputstatus

End Function

'Leer_Entrada_Analogica(Byte num)      Gets  the current analogue input value of
'                         EX or EY (num = 0 or 1).
'
Public Function Leer_Entrada_Analogica(num As Byte) As Integer

Select Case num
Case 0
  FormFischer.FischerComm.Output = Chr$(197) + Chr$(MotorValores)  ' read EX
Case 1
  FormFischer.FischerComm.Output = Chr$(201) + Chr$(MotorValores)  ' read EY
End Select

Do
    inString$ = FormFischer.FischerComm.Input                ' read 3 Byte answer
Loop Until Len(inString$) >= 3               ' 1. Byte is status of Inputnumber 1..8
                                             ' Byte 2 and 3 is the analog input

Leer_Entrada_Analogica = (Asc(Mid(inString$, 2, 1)) * 256) + Asc(Right(inString$, 1))
  
End Function
